# Generated automatically from Makefile.in by configure.
# Visual C++ 2.x and 4.0 makefile
#
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
# 
# Copyright (c) 1995-1996 Sun Microsystems, Inc.
# SCCS: @(#) makefile.vc 1.63 97/08/13 13:33:32

# Does not depend on the presence of any environment variables in
# order to compile tcl; all needed information is derived from 
# location of the compiler directories.

# This file is CYGNUS LOCAL.  It is a copy of makefile.vc from the
# standard tk distribution, modified to work with cygwin32 and an
# autoconf configure script.  I have chosen to minimize the number of
# changes, so the comments continue to refer to Visual C++ and the
# like.  This should make it easier to merge in a new version if that
# is necessary.

prefix = /usr/local
exec_prefix = /usr/local
VPATH = .:./../xlib:./../generic:./../unix:./../win/rc
srcdir = .

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644

CC = gcc
CFLAGS = -g -O2
NM = nm
AS = as
LD = ld
DLLTOOL = dlltool
DLLWRAP = dllwrap 
WINDRES = windres

DLL_LDFLAGS = -mwindows -Wl,-e,_DllMain@12
DLL_LDLIBS = 

# Current Tk version;  used in various names.

DIRVERSION = 8.0

# The following definition can be set to non-null for special systems
# like AFS with replication.  It allows the pathnames used for installation
# to be different than those used for actually reference files at
# run-time.  INSTALL_ROOT is prepended to $prefix and $exec_prefix
# when installing files.
INSTALL_ROOT =

# Directory from which applications will reference the library of Tcl
# scripts (note: you can set the TK_LIBRARY environment variable at
# run-time to override the compiled-in location):
TK_LIBRARY =		${prefix}/lib/tk$(DIRVERSION)

# Path name to use when installing library scripts:
SCRIPT_INSTALL_DIR =	$(INSTALL_ROOT)$(TK_LIBRARY)

# Directory in which to install the .a or .so binary for the Tk library:
LIB_INSTALL_DIR =	$(INSTALL_ROOT)${exec_prefix}/lib

# Directory in which to install the program wish:
BIN_INSTALL_DIR =	$(INSTALL_ROOT)${exec_prefix}/bin

# Directory in which to install the include file tk.h:
INCLUDE_INSTALL_DIR =	$(INSTALL_ROOT)${prefix}/include

# Directory in which to install the X11 header files.  These files are
# not machine independent, so they should not go in includedir.
X11_INCLUDE_INSTALL_DIR = $(INSTALL_ROOT)/usr/local/i386-mingw32/include/X11

DEMOPROGS = browse hello ixset rmt rolodex square tcolor timer widget

#
# Project directories
#
# ROOT    = top of source tree
#
# TMPDIR  = location where .obj files should be stored during build
#
# TOOLS32 = location of VC++ 32-bit development tools. Note that the
#	    VC++ 2.0 header files are broken, so you need to use the
#	    ones that come with the developer network CD's, or later
#	    versions of VC++.
#
# TCLDIR = location of top of Tcl source heirarchy
#

ROOT	= $(srcdir)/..
TMPDIR	= .
TOOLS32	= c:\msdev
TCLDIR	= $(srcdir)/../../tcl8.0.3

# Set this to the appropriate value of /MACHINE: for your platform
MACHINE	= IX86

# Comment the following line to compile with symbols
NODEBUG=1

# uncomment the following two lines to compile with TCL_MEM_DEBUG
#DEBUGDEFINES	=-DTCL_MEM_DEBUG

######################################################################
# Do not modify below this line
######################################################################

VERSION = 80

TCLDLL = tcl$(VERSION).dll
TCLLIB = libtcl$(VERSION).a
TCLPLUGINDLL = tcl$(VERSION)p.dll
TCLPLUGINLIB = libtcl$(VERSION)p.a
TKDLL = tk$(VERSION).dll
TKLIB = libtk$(VERSION).a
TKPLUGINDLL = tk$(VERSION)p.dll
TKPLUGINLIB = libtk$(VERSION)p.a

WISH = wish$(VERSION).exe
WISHP = wishp$(VERSION).exe
TKTEST = tktest.exe
DUMPEXTS = $(TMPDIR)\dumpexts.exe

WISHOBJS = \
	$(TMPDIR)/tkConsole.o \
	$(TMPDIR)/winMain.o

TKTESTOBJS = \
	$(TMPDIR)/tkConsole.o \
	$(TMPDIR)/tkTest.o \
	$(TMPDIR)/tkSquare.o \
	$(TMPDIR)/testMain.o

XLIBOBJS = \
	$(TMPDIR)/xcolors.o \
	$(TMPDIR)/xdraw.o \
	$(TMPDIR)/xgc.o \
	$(TMPDIR)/ximage.o \
	$(TMPDIR)/xutil.o

TKOBJS = \
	$(TMPDIR)/tkUnixMenubu.o \
	$(TMPDIR)/tkUnixScale.o \
	$(XLIBOBJS) \
	$(TMPDIR)/tkWin3d.o \
	$(TMPDIR)/tkWin32Dll.o \
	$(TMPDIR)/tkWinButton.o \
	$(TMPDIR)/tkWinClipboard.o \
	$(TMPDIR)/tkWinColor.o \
	$(TMPDIR)/tkWinCursor.o \
	$(TMPDIR)/tkWinDialog.o \
	$(TMPDIR)/tkWinDraw.o \
	$(TMPDIR)/tkWinEmbed.o \
	$(TMPDIR)/tkWinFont.o \
	$(TMPDIR)/tkWinImage.o \
	$(TMPDIR)/tkWinInit.o \
	$(TMPDIR)/tkWinKey.o \
	$(TMPDIR)/tkWinMenu.o \
	$(TMPDIR)/tkWinPixmap.o \
	$(TMPDIR)/tkWinPointer.o \
	$(TMPDIR)/tkWinRegion.o \
	$(TMPDIR)/tkWinScrlbr.o \
	$(TMPDIR)/tkWinSend.o \
	$(TMPDIR)/tkWinWindow.o \
	$(TMPDIR)/tkWinWm.o \
	$(TMPDIR)/tkWinX.o \
	$(TMPDIR)/stubs.o \
	$(TMPDIR)/tk3d.o \
	$(TMPDIR)/tkArgv.o \
	$(TMPDIR)/tkAtom.o \
	$(TMPDIR)/tkBind.o \
	$(TMPDIR)/tkBitmap.o \
	$(TMPDIR)/tkButton.o \
	$(TMPDIR)/tkCanvArc.o \
	$(TMPDIR)/tkCanvBmap.o \
	$(TMPDIR)/tkCanvImg.o \
	$(TMPDIR)/tkCanvLine.o \
	$(TMPDIR)/tkCanvPoly.o \
	$(TMPDIR)/tkCanvPs.o \
	$(TMPDIR)/tkCanvText.o \
	$(TMPDIR)/tkCanvUtil.o \
	$(TMPDIR)/tkCanvWind.o \
	$(TMPDIR)/tkCanvas.o \
	$(TMPDIR)/tkClipboard.o \
	$(TMPDIR)/tkCmds.o \
	$(TMPDIR)/tkColor.o \
	$(TMPDIR)/tkConfig.o \
	$(TMPDIR)/tkCursor.o \
	$(TMPDIR)/tkEntry.o \
	$(TMPDIR)/tkError.o \
	$(TMPDIR)/tkEvent.o \
	$(TMPDIR)/tkFileFilter.o \
	$(TMPDIR)/tkFocus.o \
	$(TMPDIR)/tkFont.o \
	$(TMPDIR)/tkFrame.o \
	$(TMPDIR)/tkGC.o \
	$(TMPDIR)/tkGeometry.o \
	$(TMPDIR)/tkGet.o \
	$(TMPDIR)/tkGrab.o \
	$(TMPDIR)/tkGrid.o \
	$(TMPDIR)/tkImage.o \
	$(TMPDIR)/tkImgBmap.o \
	$(TMPDIR)/tkImgGIF.o \
	$(TMPDIR)/tkImgPPM.o \
	$(TMPDIR)/tkImgPhoto.o \
	$(TMPDIR)/tkImgUtil.o \
	$(TMPDIR)/tkListbox.o \
	$(TMPDIR)/tkMacWinMenu.o \
	$(TMPDIR)/tkMain.o \
	$(TMPDIR)/tkMenu.o \
	$(TMPDIR)/tkMenubutton.o \
	$(TMPDIR)/tkMenuDraw.o \
	$(TMPDIR)/tkMessage.o \
	$(TMPDIR)/tkOption.o \
	$(TMPDIR)/tkPack.o \
	$(TMPDIR)/tkPlace.o \
	$(TMPDIR)/tkPointer.o \
	$(TMPDIR)/tkRectOval.o \
	$(TMPDIR)/tkScale.o \
	$(TMPDIR)/tkScrollbar.o \
	$(TMPDIR)/tkSelect.o \
	$(TMPDIR)/tkText.o \
	$(TMPDIR)/tkTextBTree.o \
	$(TMPDIR)/tkTextDisp.o \
	$(TMPDIR)/tkTextImage.o \
	$(TMPDIR)/tkTextIndex.o \
	$(TMPDIR)/tkTextMark.o \
	$(TMPDIR)/tkTextTag.o \
	$(TMPDIR)/tkTextWind.o \
	$(TMPDIR)/tkTrig.o \
	$(TMPDIR)/tkUtil.o \
	$(TMPDIR)/tkVisual.o \
	$(TMPDIR)/tkWindow.o

cc32		= $(TOOLS32)\bin\cl.exe
link32		= $(TOOLS32)\bin\link.exe
rc32		= $(TOOLS32)\bin\rc.exe
include32	= -I$(TOOLS32)\include

WINDIR          = $(ROOT)/win
GENERICDIR	= $(ROOT)/generic
XLIBDIR		= $(ROOT)/xlib
BITMAPDIR	= $(ROOT)/bitmaps
TCLLIBDIR       = ../../tcl8.0.3/win
RCDIR		= $(WINDIR)/rc

TK_INCLUDES	= -I$(WINDIR) -I$(GENERICDIR) -I$(BITMAPDIR) -I$(XLIBDIR) \
			-I$(TCLDIR)/generic
TK_DEFINES	= $(DEBUGDEFINES)

TK_CFLAGS	= $(cdebug) $(cflags) $(cvarsdll) $(include32) \
			$(TK_INCLUDES) $(TK_DEFINES) $(CFLAGS)

######################################################################
# Link flags
######################################################################

#!IFDEF NODEBUG
#ldebug = /RELEASE
#!ELSE
#ldebug = -debug:full -debugtype:cv
#!ENDIF

# declarations common to all linker options
lcommon = /NODEFAULTLIB /RELEASE /NOLOGO

# declarations for use on Intel i386, i486, and Pentium systems
#!IF "$(MACHINE)" == "IX86"
#DLLENTRY = @12
#lflags   = $(lcommon) -align:0x1000 /MACHINE:$(MACHINE)
#!ELSE
#lflags   = $(lcommon) /MACHINE:$(MACHINE)
#!ENDIF

conlflags = $(lflags) -Wl,--subsystem,console -mwindows
guilflags = $(lflags) -mwindows
dlllflags = $(lflags)

#!IF "$(MACHINE)" == "PPC"
#libc = libc.lib
#libcdll = crtdll.lib
#!ELSE
#libc = libc.lib oldnames.lib
#libcdll = msvcrt.lib oldnames.lib
#!ENDIF

baselibs   = -lkernel32 $(optlibs) -ladvapi32
winlibs    = $(baselibs) -luser32 -lgdi32 -lcomdlg32 -lwinspool
guilibs	   = $(libc) $(winlibs)

guilibsdll = $(libcdll) $(winlibs)

######################################################################
# Compile flags
######################################################################

#!IFDEF NODEBUG
#cdebug = -Ox
#!ELSE
#cdebug = -Z7 -Od -WX
#!ENDIF

# declarations common to all compiler options
#ccommon = -c -W3 -nologo -YX

#!IF "$(MACHINE)" == "IX86"
#cflags = $(ccommon) -D_X86_=1
#!ELSE
#!IF "$(MACHINE)" == "MIPS"
#cflags = $(ccommon) -D_MIPS_=1
#!ELSE
#!IF "$(MACHINE)" == "PPC"
#cflags = $(ccommon) -D_PPC_=1
#!ELSE
#!IF "$(MACHINE)" == "ALPHA"
#cflags = $(ccommon) -D_ALPHA_=1
#!ENDIF
#!ENDIF
#!ENDIF
#!ENDIF

cvars      = -DWIN32 -D_WIN32
cvarsmt    = $(cvars) -D_MT
cvarsdll   = $(cvarsmt) -D_DLL

CON_CFLAGS	= $(cdebug) $(cflags) $(cvars) $(include32) -DCONSOLE

######################################################################
# Project specific targets
######################################################################

all:    $(TKDLL) $(TKLIB) $(WISH)
test:	$(TKTEST)
plugin:	$(TKPLUGINDLL) $(WISHP)

install: install-binaries install-libraries install-demos

install-binaries: $(TKDLL) $(TKLIB) $(WISH)
	@for i in $(LIB_INSTALL_DIR) $(BIN_INSTALL_DIR) ; \
	    do \
	    if [ ! -d $$i ] ; then \
		echo "Making directory $$i"; \
		mkdir $$i; \
		chmod 755 $$i; \
		else true; \
		fi; \
	    done;
	@echo "Installing $(TKLIB)"
	@$(INSTALL_DATA) $(TKLIB) $(LIB_INSTALL_DIR)/$(TKLIB)
	@chmod 555 $(LIB_INSTALL_DIR)/$(TKLIB)
	@echo "Installing wish"
	@$(INSTALL_PROGRAM) $(WISH) $(BIN_INSTALL_DIR)/$(WISH)
	@echo "Installing tkConfig.sh"
	@$(INSTALL_DATA) ../unix/tkConfig.sh $(LIB_INSTALL_DIR)/tkConfig.sh

install-libraries:
	@echo "Installing DLL"
	@$(INSTALL_DATA) $(TKDLL) $(BIN_INSTALL_DIR)/$(TKDLL)
	@for i in $(INSTALL_ROOT)${prefix}/lib $(INCLUDE_INSTALL_DIR) \
		$(SCRIPT_INSTALL_DIR) $(INSTALL_ROOT)/usr/local \
		$(INSTALL_ROOT)/usr/local/i386-mingw32 \
		$(INSTALL_ROOT)/usr/local/i386-mingw32/include \
		$(X11_INCLUDE_INSTALL_DIR) ; \
	    do \
	    if [ ! -d $$i ] ; then \
		echo "Making directory $$i"; \
		mkdir $$i; \
		chmod 755 $$i; \
		else true; \
		fi; \
	    done;
	@echo "Installing tk.h"
	@$(INSTALL_DATA) $(GENERICDIR)/tk.h $(INCLUDE_INSTALL_DIR)/tk.h
	for i in $(XLIBDIR)/X11/*.h; \
	    do \
	    echo "Installing $$i"; \
	    $(INSTALL_DATA) $$i $(X11_INCLUDE_INSTALL_DIR); \
	    done;
	for i in $(ROOT)/library/*.tcl $(ROOT)/library/tclIndex $(ROOT)/library/prolog.ps $(ROOT)/unix/tkAppInit.c; \
	    do \
	    echo "Installing $$i"; \
	    $(INSTALL_DATA) $$i $(SCRIPT_INSTALL_DIR); \
	    done;

install-minimal:
	@echo "Installing DLL"
	@$(INSTALL_DATA) $(TKDLL) $(BIN_INSTALL_DIR)/$(TKDLL)
	@for i in $(INSTALL_ROOT)${prefix}/lib $(SCRIPT_INSTALL_DIR) ; \
	    do \
	    if [ ! -d $$i ] ; then \
		echo "Making directory $$i"; \
		mkdir $$i; \
		chmod 755 $$i; \
		else true; \
		fi; \
	    done;
	for i in $(ROOT)/library/*.tcl $(ROOT)/library/tclIndex $(ROOT)/library/prolog.ps; \
	    do \
	    echo "Installing $$i"; \
	    $(INSTALL_DATA) $$i $(SCRIPT_INSTALL_DIR); \
	    done;

install-demos:
	@for i in $(INSTALL_ROOT)${prefix}/lib $(SCRIPT_INSTALL_DIR) \
		$(SCRIPT_INSTALL_DIR)/demos \
		$(SCRIPT_INSTALL_DIR)/demos/images ; \
	    do \
	    if [ ! -d $$i ] ; then \
		echo "Making directory $$i"; \
		mkdir $$i; \
		chmod 755 $$i; \
		else true; \
		fi; \
	    done;
	@for i in $(ROOT)/library/demos/*; \
	    do \
	    if [ -f $$i ] ; then \
		echo "Installing $$i"; \
		sed -e '3 s|exec wish|exec $(WISH)|' \
			$$i > $(SCRIPT_INSTALL_DIR)/demos/`basename $$i`; \
	    fi; \
	    done;
	@for i in $(DEMOPROGS); \
	    do \
	    chmod 755 $(SCRIPT_INSTALL_DIR)/demos/$$i; \
	    done;
	@for i in $(ROOT)/library/demos/images/*; \
	    do \
	    if [ -f $$i ] ; then \
		echo "Installing $$i"; \
		$(INSTALL_DATA) $$i $(SCRIPT_INSTALL_DIR)/demos/images; \
		fi; \
	    done;

$(TKDLL): $(TKOBJS) tkres.o tkcyg.def
	$(DLLWRAP) -s $(DLL_LDFLAGS) -o $(TKDLL) \
	  --def tkcyg.def $(TKOBJS) tkres.o \
	  $(TCLLIBDIR)/$(TCLLIB) $(DLL_LDLIBS) -Wl,--image-base,0x66300000

$(TKLIB): $(TMPDIR)/tkcyg.def
	$(DLLTOOL) --as=$(AS) --dllname $(TKDLL) --def $(TMPDIR)/tkcyg.def \
	  --output-lib $(TKLIB)

$(TKPLUGINLIB): $(TMPDIR)/plugin.def
	$(DLLTOOL) --as=$(AS) --dllname $(TKPLUGINDLL) \
	  --def $(TMPDIR)/plugin.def --output-lib $(TKPLUGINLIB)

$(TKPLUGINDLL): $(TKOBJS) tkres.o $(TMPDIR)/plugin.def
	$(DLLWRAP) $(DLL_LDFLAGS) -o $(TKPLUGINDLL) \
	  --def plugin.def $(TKOBJS) tkres.o \
	  $(TCLLIBDIR)/$(TCLLIB) $(DLL_LDLIBS) -Wl,--image-base,0x66800000

$(WISH): $(WISHOBJS) wishres.o $(TKLIB)
	$(CC) $(ldebug) $(guilflags) $(WISHOBJS) wishres.o -o $@ \
		$(TKLIB) $(TCLLIBDIR)/$(TCLLIB) $(guilibsdll)

$(WISHP): $(WISHOBJS) $(TKPLUGINLIB) wishres.o
	$(CC) $(ldebug) $(guilflags) $(WISHOBJS) wishres.o -o $@ \
		$(TKPLUGINLIB) $(TCLLIBDIR)/$(TCLPLUGINLIB) $(guilibsdll)

$(TKTEST): $(TKTESTOBJS) wishres.o $(TKLIB)
	$(CC) $(ldebug) $(guilflags) $(TKTESTOBJS) wishres.o -o $@ \
		$(TKLIB) $(TCLLIBDIR)/$(TCLLIB) $(guilibsdll)

tkcyg.def: $(TKOBJS)
	$(DLLTOOL) --export-all --output-def $@ $(TKOBJS)

plugin.def: $(TKOBJS)
	$(DLLTOOL) --export-all --output-def $@ $(TKOBJS)

$(DUMPEXTS): $(TCLDIR)\win\winDumpExts.c
	$(cc32) $(CON_CFLAGS) -Fo$(TMPDIR)\ $?
	set LIB=$(TOOLS32)\lib
	$(link32) $(ldebug) $(conlflags) $(guilibs) -out:$@ \
		$(TMPDIR)\winDumpExts.obj 

#
# Special case object file targets
#

$(TMPDIR)/testMain.o: $(ROOT)/win/winMain.c
	$(CC) -c $(TK_CFLAGS) -DTK_TEST -o $@ $?

#
# Implicit rules
#

.c.o:
	$(CC) -c $(TK_CFLAGS) $<

tkres.o: $(ROOT)/win/rc/tk.rc
	$(WINDRES) --include $(ROOT)/win/rc --include $(ROOT)/generic \
	  --define VS_VERSION_INFO=1 $(ROOT)/win/rc/tk.rc tkres.o

wishres.o: $(ROOT)/win/rc/wish.rc
	$(WINDRES) --include $(ROOT)/win/rc --include $(ROOT)/generic \
	  --define VS_VERSION_INFO=1 $(ROOT)/win/rc/wish.rc wishres.o

#{$(ROOT)\win\rc}.rc{$(TMPDIR)}.res:
#	$(rc32) -fo $@ -r -i $(ROOT)\generic $<

clean:
	rm -f *.exp *.a *.dll *.exe $(TMPDIR)/*.o *.res *.def
	rm -f tk.base tkplugin.base

# dependencies

$(TMPDIR)/tk.res: \
    $(RCDIR)/buttons.bmp \
    $(RCDIR)/cursor*.cur \
    $(RCDIR)/tk.ico

$(GENERICDIR)/default.h: $(WINDIR)/tkWinDefault.h
$(GENERICDIR)/tkButton.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkCanvas.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkEntry.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkFrame.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkListbox.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkMenu.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkMenubutton.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkMessage.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkScale.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkScrollbar.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkText.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkTextIndex.c: $(GENERICDIR)/default.h
$(GENERICDIR)/tkTextTag.c: $(GENERICDIR)/default.h

$(GENERICDIR)/tkText.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextBTree.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextDisp.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextDisp.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextImage.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextIndex.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextMark.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextTag.c: $(GENERICDIR)/tkText.h
$(GENERICDIR)/tkTextWind.c: $(GENERICDIR)/tkText.h

$(GENERICDIR)/tkMacWinMenu.c: $(GENERICDIR)/tkMenu.h
$(GENERICDIR)/tkMenu.c: $(GENERICDIR)/tkMenu.h
$(GENERICDIR)/tkMenuDraw.c: $(GENERICDIR)/tkMenu.h
$(WINDIR)/tkWinMenu.c: $(GENERICDIR)/tkMenu.h

